from django.shortcuts import render,redirect
from django.contrib.auth.decorators import user_passes_test
from django.utils.decorators import method_decorator
from rest_framework.response import Response
from django.http import JsonResponse
from rest_framework import status
from rest_framework.views import APIView
#import json , requests
from django.conf import settings as stg
from django.db.models import Sum
import json
from itertools import chain # Join Multiple Querysets From Different Base Models Django
from django.apps import apps
from clvoucherApp.models import Voucher
# Create your views here.
#from .models import PatientExternalPayment
from .models import *
from .serializers import *
from clmainApp.utils import *
from brvisitApp.models import PatientVisit
from brsessionApp.models import Session,ASSESSMENT_CODE_CHOICES
from django.db.models.functions import Coalesce
############## Patient%Module #################
class PatientsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_patients'), login_url='/auth/login/'))
    def get(self,request):
        # if dr  , get current branch patients
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        #user = request.user
        all_patients =Patient.objects.filter(branch_id=branchId,code__gt=0)
        all_patients_serialized=PatientSerializer(all_patients,many=True)
        all_locations = Location.objects.filter(branch_id= branchId)
        all_found_ways = FoundWay.objects.all()
        return render(request,"Branch/brpatientApp/patients.html",{
            "all_patients":all_patients_serialized.data,
            "found_ways": all_found_ways,
            "locations": all_locations,
            # "branches":branches,
            # "all_found_ways": all_found_ways,
            # "all_nationalities": all_nationalities,
            # "all_locations": all_locations,
            # "all_complaints": all_complaints.data,
            # "all_channels": all_channels,
            # "all_programs": all_programs,
            #"clinic_id": clinicId,
            'activePage':'Patients'})
    #method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.add_patient', 'Reception.addPatient']), login_url='/auth/login/'))
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_patient'), login_url='/auth/login/'))    
    def post(self,request):
        #print("handle add patient")
        branchId = getBranchId(request)
        #clinicId = getClinicId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        data = request.data
        data._mutable = True
        user_id = request.user.id
        data.update({"created_by":user_id,"branch":branchId})
        patients = Patient.objects.filter(branch_id=branchId).aggregate(max_code=Coalesce(Max('code'),0))
        new_patient_code = int(patients["max_code"]) + 1
        data.update({"code":new_patient_code})
        serializedObj= PatientSerializer(data=data)
        if serializedObj.is_valid():
            serializedObj.save()
            response_data = serializedObj.data
            PatientInfo.objects.create(patient_id=response_data["id"],last_update_by_id=user_id)
            return Response(response_data, status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
from django.db.models import Q
from brsessionApp.serializers import PsiAssessment,PsiAssessmentSerializer

class PatientApi(APIView):
    def get_object(self,pk):
        try:
            return Patient.objects.get(pk=pk)
        except Patient.DoesNotExist:
            return None    
    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_patients'), login_url='/auth/login/'))        
    def get(self,request,pk):
        branchId = getBranchId(request)
        patient=self.get_object(pk)
        if patient :
            if patient.branch_id !=  branchId : 
                if request.user.is_superuser :
                    branch = Branch.objects.get(id=patient.branch_id)
                    request.session['branchName'] = branch.name
                    request.session['branchId'] = branch.id
                    request.session['welcomeImg'] = branch.welcome_img.url
                    request.session['iconImg'] = branch.icon_img.url
                    request.session['reportsCode'] = branch.reports_code
                    # if 'clinicName' in request.session: del request.session['clinicName']
                    # if 'clinicId' in request.session: del request.session['clinicId']
                else : return redirect("brpatientApp:PatientsApi")
            #template_name =f"Branch/brpatientApp/patient.html"
            template_name =f"Branch/brpatientApp/patient_dr_ramy.html"
            patient_serialized=PatientSerializer(patient)
            context = {"patient":patient_serialized.data,'activePage':'Patients'}
            #print(access_token_global)
            context.update({ "access_token_global":access_token_global,})
            #psi_data  = PatientSessionItem.objects.filter(session__patient_id=pk,session_status_id__in=["2AT"]).order_by('-session_day')
            psi_data  = PatientSessionItem.objects.filter(session__patient_id=pk).order_by('-session_day')
            #psi_data_doctors  = psi_data.values_list('confirmed_by', flat=True)
            psi_data_doctors  = psi_data.values_list('doctor', flat=True)
            # Step 2: Create a set to ensure uniqueness
            unique_doctor_ids = set(psi_data_doctors)
            assessment_doctors = []
            for dr_id in unique_doctor_ids:
                if dr_id == None : continue
                obj = psi_data.filter(doctor_id=dr_id).first()
                assessment_doctors.append({"id":dr_id,"name":obj.doctor.name})
            
            #active_sessions  = psi_data.filter( ~Q(entry_status__in=["5A", "6C"])).order_by('id')
            #active_sessions  = psi_data.filter( Q(session_status__code="2AT")).order_by('id')
            timezone_now_today = timezone.now().date()
            active_sessions  = psi_data.filter(session_day__lte=timezone_now_today).order_by('id')
            enumerated_sessions = [(index + 1, session) for index, session in enumerate(active_sessions)]
            even_sessions_ids = [session.id for index, session in enumerated_sessions if index % 2 == 0]
            context.update({'psi_data':psi_data,"even_sessions_ids":even_sessions_ids,
                            "today_date":timezone_now_today,"assessment_doctors":assessment_doctors})
            psi_assessments= PsiAssessment.objects.filter(patient=patient).order_by('-created_at')
            psi_assessment_srl = PsiAssessmentSerializer(psi_assessments,many=True)
            context.update({'psi_assessments':psi_assessment_srl.data})
            #ModelClassObject = apps.get_model(app_label_string,model_name_string)
            visits = PatientVisit.objects.filter(patient=patient,visit_status__in=["1I","2W","4F"]).order_by('-visit_day')            
            visits_serializer = PatientVisitMiniSerializer(visits,many=True)
            context.update({'visits':visits_serializer.data})
            branch_vouchers =Voucher.objects.filter(branch_id=branchId,is_active=True).values("id","name","voucher_code","description",
                            "discount_value_sessions","max_sessions","discount_value_visits","max_visits","validity_days")
            context.update({'branch_vouchers':branch_vouchers})
            try :
                patientInfoObj = PatientInfo.objects.get(patient=patient)
                context.update({'pI':patientInfoObj})
            except PatientInfo.DoesNotExist:
                context.update({'pI':None})
            evaluations_cards = PtEvaluationCard.objects.filter(patient=patient).order_by('-created_at')
                #cards_ids = evaluations_cards.values_list('id')
                #evaluation_exrecises  = EvalutaionExercise.objects.filter(evaluation_id__in = cards_ids)
                #for card in evaluations_cards : card.exercises = evaluation_exrecises.filter (evaluation_id = card.id)
            context.update({"is_notes_editable":request.user.is_notes_editable,})
            context.update({"evaluations_cards":evaluations_cards,})
            context.update({"blood_types":BLOOD_TYPE_CHOICES,"smoking_statuses":SMOKING_STATUS_CHOICES,})
            context.update({"difficulty_choices":DIFFICULTY_CHOICES,"mechanical_assessment_choices":MECHANICAL_ASSESSMENT_CHOICES,})
            context.update({"tp_release_choices":TP_RELEASE_CHOICES,"tp_stretch_choices":TP_STRETCH_CHOICES,"tp_strength_choices":TP_STRENGTH_CHOICES,})
            context.update({"patient_status":PatientStatus.objects.all().order_by('ps_order').values('id','name'),})
            context.update({"pageTitle":patient.fullname,'MARKETING_CODE_CHOICES':MARKETING_CODE_CHOICES,})
            context.update({"sessions":Session.objects.filter(is_active=True,branch_id=branchId).values('id','name')})
            context.update({"assessment_codes":ASSESSMENT_CODE_CHOICES})

            return render(request,template_name,context)
        else : return redirect("brpatientApp:PatientsApi")

    #@method_decorator(user_passes_test(lambda u: any(u.has_perm(perm) for perm in ['BrManagement.change_patient', 'Reception.addPatient']), login_url='/auth/login/'))
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_patient'), login_url='/auth/login/'))
    def put(self,request,pk):
        obj=self.get_object(pk)
        # clinicId = getClinicId(request)
        # if not clinicId : return redirect('clauthApp:home')
        request.data._mutable = True
        #request.data.update({"created_by":request.user.id,"clinic":clinicId})
        serializedObj= PatientSerializer(obj,data=request.data,partial=True)
        #list_error=""
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.delete_patient'), login_url='/auth/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)

class PatientInfoApi(APIView):
    def get_object(self,pk):
        try:
            return PatientInfo.objects.get(patient=pk)
        except PatientInfo.DoesNotExist:
            return None    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.edit_patient_info'), login_url='/auth/login/'))        
    def put(self,request,pk):
        obj=self.get_object(pk)
        request.data._mutable = True
        request.data.update({"last_update_by":request.user.id})
        #request.data.update({"last_update_at":timezone.now()})
        request.data.update({"patient":pk})
        if obj : 
            serializedObj= PatientInfoSerializer(obj,data=request.data)
        else :
            serializedObj= PatientInfoSerializer(data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()        
            #last_update_at = datetime.strptime(serializedObj.data["last_update_at"], "%Y-%m-%dT%H:%M:%S.%f%z").strftime("%H:%M:%S.%f %Y-%m-%d")
            #last line generating an error : ValueError: time data '2024-01-07T15:37:13.299577' does not match format '%Y-%m-%dT%H:%M:%S.%f%z'
            last_update_at = datetime.strptime(serializedObj.data["last_update_at"],'%Y-%m-%dT%H:%M:%S.%f').strftime("%H:%M:%S.%f %Y-%m-%d")
            return Response(last_update_at,status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
class PatientPaymentApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.show_patient_payment'), login_url='/auth/login/'))        
    def get(self,request,patient_pk):       
        filtered_patient_visits =PatientVisit.objects.filter(patient_id=patient_pk).values('created_at','medicalservice__name','amount_required','amount_paid','amount_remaining','created_by__first_name','created_by__last_name').order_by("-created_at")
        #filtered_external_payments =PatientExternalPayment.objects.filter(patient_id=patient_pk).values('created_at','amount_paid','notes','created_by__first_name','created_by__last_name').order_by("-created_at")
        visits_sessions_extPayments = chain(#Join Multiple Querysets From Different Base Models Django
        filtered_patient_visits,
        #filtered_external_payments
        ) 
        data_sorted = sorted(visits_sessions_extPayments, key=lambda x: x['created_at'], reverse=True)# sort list of dict by value of Key (created_at)
        data_sorted_json = [json.dumps(i,default=jsonSerializerIfDateTime) for i in data_sorted] 
        return JsonResponse({"visits_sessions_extPayments":data_sorted_json})
class PatientBalanceApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.show_patient_balance'), login_url='/auth/login/'))        
    def get(self,request,patient_pk):
        pV =PatientVisit.objects.filter(patient_id=patient_pk).aggregate(total_amount_required=Sum('amount_required'),total_amount_paid=Sum('amount_paid'))
        #{'total_amount_required': 3800, 'total_amount_paid': 3250, 'total_amount_remaining': 550}
        eP =PatientExternalPayment.objects.filter(patient_id=patient_pk).aggregate(total_amount_paid=Sum('amount_paid'))
        #{'total_amount_paid': 800}
        total_amount_required_pv = pV["total_amount_required"] if pV["total_amount_required"] != None else 0
        total_amount_paid_pv = pV["total_amount_paid"] if pV["total_amount_paid"] != None else 0
        #total_amount_remaining_pv = pV["total_amount_remaining"] if pV["total_amount_remaining"] != None else 0 
        total_amount_paid_ep = eP["total_amount_paid"] if eP["total_amount_paid"] != None else 0
        total_balance = (total_amount_required_pv ) - (total_amount_paid_pv+total_amount_paid_ep)
        p = Patient.objects.get(pk=patient_pk)
        p.balance=total_balance
        p.save()
        return JsonResponse({"total_balance":total_balance})
class PtAttachmentsApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.show_pt_attachment'), login_url='/auth/login/'))        
    def get(self,request,patient_pk):       
        p_attachments =PtAttachment.objects.filter(patient_id=patient_pk).order_by("-created_at")
        p_attachments_srl=PtAttachmentSerializer(p_attachments,many=True)
        return Response(p_attachments_srl.data , status=status.HTTP_201_CREATED)
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_pt_attachment'), login_url='/auth/login/'))    
    def post(self,request,patient_pk):
        request.data._mutable = True
        request.data.update({"created_by":request.user.id})
        request.data.update({"patient":patient_pk})
        serializedObj= PtAttachmentSerializer(data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
class PtAttachmentApi(APIView):
    def get_object(self,pk):
        try:
            return PtAttachment.objects.get(pk=pk)
        except PtAttachment.DoesNotExist:
            return None    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.edit_medicalService'), login_url='/auth/login/'))
    def put(self,request,pk):
        obj=self.get_object(pk)
        request.data._mutable = True
        request.data.update({"created_by":request.user.id})
        serializedObj= PtAttachmentUpdateSerializer(obj,data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

############## END Patient%Module #################
class PatientExternalPaymentsApi(APIView):
    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_patients'), login_url='/main/login/'))
    # def get(self,request):
    #     if not getClinicId(request) : return redirect('/main/login/')
    #     all_patients =Patient.objects.all()
    #     all_patients_serialized=PatientSerializer(all_patients,many=True)
    #     return render(request,"mainApp/patientPages/patients.html",{"all_patients":all_patients_serialized.data,'activePage':'Patients'})

    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_patients'), login_url='/main/login/'))    
    def post(self,request):
        if not getClinicId(request) : return redirect('/main/login/')
        request.data._mutable = True
        request.data.update({"created_by":request.user.id})
        serializedObj= PatientExternalPaymentSerializer(data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

class PtCardsApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_Organization'), login_url='/main/login/'))    
    def post(self,request,patient_pk):
        #if not getClinicId(request) : return redirect('/main/login/')
        request.data._mutable = True
        request.data.update({"created_by":request.user.id})
        request.data.update({"patient":patient_pk})
        serializedObj= PtEvaluationCardSerializer(data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_201_CREATED)
        else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
class PtCardApi(APIView):
    def get_object(self,pk):
        try:
            return PtEvaluationCard.objects.get(pk=pk)
        except PtEvaluationCard.DoesNotExist:
            return None    

    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.edit_medicalService'), login_url='/main/login/'))
    def put(self,request,pk):
        obj=self.get_object(pk)
        request.data._mutable = True
        request.data.update({"created_by":request.user.id})
        serializedObj= PtEvaluationCardUpdateSerializer(obj,data=request.data)
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

##RomAssessment
class PtRomAssessmentsApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_CurrentVisits'), login_url='/main/login/'))
    def get(self,request,patient_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        rom_assessments =PtRomAssessment.objects.filter(patient_id=patient_id).order_by("visit_day")
        serializer=PtRomAssessmentSerializer(rom_assessments,many=True)
        return Response(serializer.data , status=status.HTTP_201_CREATED)

    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_PatientVisit'), login_url='/main/login/'))    
    def post(self,request,patient_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        data = request.data
        data._mutable = True
        data.update({"patient":patient_id,"created_by":request.user.id})
        serializer= PtRomAssessmentSerializer(data=data)
        if serializer.is_valid():
            serializer.save()
            return Response(serializer.data , status=status.HTTP_201_CREATED)
        else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

class PtRomAssessmentApi(APIView):
    def get_object(self,pk):
        try:
            return PtRomAssessment.objects.get(pk=pk)
        except PtRomAssessment.DoesNotExist:
            return None 
        
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_toRateSessions'), login_url='/main/login/'))
    def delete(self,request,rom_id):
        obj=self.get_object(rom_id)
        if obj :
            try:
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)


class IrregularPtDataApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_pt_attachment'), login_url='/auth/login/'))    
    def post(self,request,patient_pk):
        pt_obj, created = IrregularPtData.objects.get_or_create(patient_id=patient_pk)
        data = request.data
        user_id = request.user.id
        data._mutable = True
        if data["page_source"]== "Clinic":data.update({"cl_created_by":user_id,"cl_created_at":timezone.now(),})    
        else : data.update({"br_created_by":user_id,"br_created_at":timezone.now(),})    
        serializedObj= IrregularPtDataSerializer(pt_obj,data=data,partial=True)
        #list_error=""
        if serializedObj.is_valid():
            serializedObj.save()
            #print(serializedObj.data)
            return Response(serializedObj.data , status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

        # if data["page_source"] == "Clinic":
        # serializedObj= PtAttachmentSerializer(data=request.data)
        # if serializedObj.is_valid():
        #     serializedObj.save()
        #     return Response(status=status.HTTP_201_CREATED)
        # else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)

    def put(self,request,patient_pk):
        pt_obj, created = IrregularPtData.objects.get_or_create(patient_id=patient_pk)
        data = request.data
        #print(data)
        #user_id = request.user.id
        data._mutable = True
        data['is_hidden'] = True if data['is_hidden'] =='true' else False
        serializedObj= IrregularPtDataSerializer(pt_obj,data=data,partial=True)
        #list_error=""
        if serializedObj.is_valid():
            serializedObj.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)



from brpatientApp.dropbox import list_files_in_dropbox_folder_metadata_only,access_token_global
class PatientFilesMetaDataApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_GeneralReport'), login_url='/main/login/'))
    def get(self,request,patient_pk,pt_fullname):
        #import pdb;pdb.set_trace()
        is_success,response_data = list_files_in_dropbox_folder_metadata_only(path='/patients/{}__{}'.format(patient_pk,pt_fullname))
        
        if is_success :
            return JsonResponse(response_data, status=200)
        else :
            return JsonResponse({"error":response_data["error"]}, status=204)

class LatestDriveFilesMetaDataApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_GeneralReport'), login_url='/main/login/'))
    def get(self,request):
        is_success,response_data = list_files_in_dropbox_folder_metadata_only(path='/Camera Uploads')
        return JsonResponse(response_data, status=200 if is_success else 400)
class LatestDriveFilesApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_GeneralReport'), login_url='/main/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        #user = request.user
        all_patients =Patient.objects.filter(branch_id=branchId).values("id","fullname","code")
        context = {
            "all_patients":all_patients,"pa_type_choices":PA_TYPE_CHOICES,
            "access_token_global":access_token_global,
            'activePage':'LatestDriveFiles'
        } 

        return render(request,"Branch/brpatientApp/latest_drive_files.html",context)